// DlgProxy.cpp : implementation file
//

#include "stdafx.h"
#include "DNADemoClientVC.h"
#include "DlgProxy.h"
#include "DNADemoClientVCDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDNADemoClientVCDlgAutoProxy

IMPLEMENT_DYNCREATE(CDNADemoClientVCDlgAutoProxy, CCmdTarget)

CDNADemoClientVCDlgAutoProxy::CDNADemoClientVCDlgAutoProxy()
{
	EnableAutomation();
	
	// To keep the application running as long as an automation 
	//	object is active, the constructor calls AfxOleLockApp.
	AfxOleLockApp();

	// Get access to the dialog through the application's
	//  main window pointer.  Set the proxy's internal pointer
	//  to point to the dialog, and set the dialog's back pointer to
	//  this proxy.
	ASSERT (AfxGetApp()->m_pMainWnd != NULL);
	ASSERT_VALID (AfxGetApp()->m_pMainWnd);
	ASSERT_KINDOF(CDNADemoClientVCDlg, AfxGetApp()->m_pMainWnd);
	m_pDialog = (CDNADemoClientVCDlg*) AfxGetApp()->m_pMainWnd;
	m_pDialog->m_pAutoProxy = this;
}

CDNADemoClientVCDlgAutoProxy::~CDNADemoClientVCDlgAutoProxy()
{
	// To terminate the application when all objects created with
	// 	with automation, the destructor calls AfxOleUnlockApp.
	//  Among other things, this will destroy the main dialog
	if (m_pDialog != NULL)
		m_pDialog->m_pAutoProxy = NULL;
	AfxOleUnlockApp();
}

void CDNADemoClientVCDlgAutoProxy::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}

BEGIN_MESSAGE_MAP(CDNADemoClientVCDlgAutoProxy, CCmdTarget)
	//{{AFX_MSG_MAP(CDNADemoClientVCDlgAutoProxy)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CDNADemoClientVCDlgAutoProxy, CCmdTarget)
	//{{AFX_DISPATCH_MAP(CDNADemoClientVCDlgAutoProxy)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_IDNADemoClientVC to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {52C1AD45-6F93-11D2-9EF3-0080C79D9EE1}
static const IID IID_IDNADemoClientVC =
{ 0x52c1ad45, 0x6f93, 0x11d2, { 0x9e, 0xf3, 0x0, 0x80, 0xc7, 0x9d, 0x9e, 0xe1 } };

BEGIN_INTERFACE_MAP(CDNADemoClientVCDlgAutoProxy, CCmdTarget)
	INTERFACE_PART(CDNADemoClientVCDlgAutoProxy, IID_IDNADemoClientVC, Dispatch)
END_INTERFACE_MAP()

// The IMPLEMENT_OLECREATE2 macro is defined in StdAfx.h of this project
// {52C1AD43-6F93-11D2-9EF3-0080C79D9EE1}
IMPLEMENT_OLECREATE2(CDNADemoClientVCDlgAutoProxy, "DNADemoClientVC.Application", 0x52c1ad43, 0x6f93, 0x11d2, 0x9e, 0xf3, 0x0, 0x80, 0xc7, 0x9d, 0x9e, 0xe1)

/////////////////////////////////////////////////////////////////////////////
// CDNADemoClientVCDlgAutoProxy message handlers
